package mqtrcfrmt.parser;

public class DataStrcUtil {
	
	public static void getDataStrcSize(TrcCtl trcCtl) {
		short MQBYTE16 = 16;
		short MQBYTE24 = 24;
		short MQBYTE32 = 32;
		short MQBYTE40 = 40;
		short MQCHAR = 1;
		short MQCHAR4 = 4;
		short MQCHAR8 = 8;
		short MQCHAR12 = 12;
		short MQCHAR28 = 28;
		short MQCHAR32 = 32;
		short MQCHAR48 = 48;
		short MQCHAR128 = 128;
		short MQCHARV = (short) (trcCtl.pointerLength + 16);
		short MQHMSG = 8;
		short MQHOBJ = 4;
		short MQLONG = 4;
		short MQPTR = trcCtl.pointerLength;
		short MQSD_padding = 0;
		
		if (trcCtl.pointerLength == 8)
			MQSD_padding = 12;
				
		switch (trcCtl.dataStrcName) {
		case "CBC" :
			switch (trcCtl.dataStrcVersion) {
			case 1 :
				trcCtl.dataStrcSize = MQCHAR4 + 8 * MQLONG + MQHOBJ + 2 * MQPTR; 
				break;
			case 2 :
				trcCtl.dataStrcSize = MQCHAR4 + 9 * MQLONG + MQHOBJ + 2 * MQPTR;
				break;
			default :
				trcCtl.dataStrcName = null;
				trcCtl.dataStrcVersion = 0;
				break;
			}
			break;
		case "CBD" :
			switch (trcCtl.dataStrcVersion) {
			case 1 :
				trcCtl.dataStrcSize = MQCHAR4 + 4 * MQLONG + 2 * MQPTR + MQCHAR128; 
				break;
			default :
				trcCtl.dataStrcName = null;
				trcCtl.dataStrcVersion = 0;
				break;
			}
			break;
		case "CMHO" :
			switch (trcCtl.dataStrcVersion) {
			case 1 :
				trcCtl.dataStrcSize = MQCHAR4 + 2 * MQLONG; 
				break;
			default :
				trcCtl.dataStrcName = null;
				trcCtl.dataStrcVersion = 0;
				break;
			}
			break;
		case "CTLO" :
			switch (trcCtl.dataStrcVersion) {
			case 1 :
				trcCtl.dataStrcSize = MQCHAR4 + 3 * MQLONG + MQPTR;
				break;
			default :
				trcCtl.dataStrcName = null;
				trcCtl.dataStrcVersion = 0;
				break;
			}
			break;
		case "DMHO" :
			switch (trcCtl.dataStrcVersion) {
			case 1 :
				trcCtl.dataStrcSize = MQCHAR4 + 2 * MQLONG; 
				break;
			default :
				trcCtl.dataStrcName = null;
				trcCtl.dataStrcVersion = 0;
				break;
			}
			break;
		case "DMPO" :
			switch (trcCtl.dataStrcVersion) {
			case 1 :
				trcCtl.dataStrcSize = MQCHAR4 + 2 * MQLONG; 
				break;
			default :
				trcCtl.dataStrcName = null;
				trcCtl.dataStrcVersion = 0;
				break;
			}
			break;
		case "GMO" :
			switch (trcCtl.dataStrcVersion) {
			case 1 :
				trcCtl.dataStrcSize = MQCHAR4 + 5 * MQLONG + MQCHAR48; 
				break;
			case 2 :
				trcCtl.dataStrcSize = MQCHAR4 + 6 * MQLONG + MQCHAR48 + 4 * MQCHAR; 
				break;
			case 3 :
				trcCtl.dataStrcSize = MQCHAR4 + 7 * MQLONG + MQCHAR48 + 4 * MQCHAR + MQBYTE16; 
				break;
			case 4 :
				trcCtl.dataStrcSize = MQCHAR4 + 8 * MQLONG + MQCHAR48 + 4 * MQCHAR + MQBYTE16 + MQHMSG; 
				break;
			default :
				trcCtl.dataStrcName = null;
				trcCtl.dataStrcVersion = 0;
				break;
			}
			break;
		case "IMPO" :
			switch (trcCtl.dataStrcVersion) {
			case 1 :
				trcCtl.dataStrcSize = MQCHAR4 + 7 * MQLONG + MQCHARV + MQCHAR8; 
				break;
			default :
				trcCtl.dataStrcName = null;
				trcCtl.dataStrcVersion = 0;
				break;
			}
			break;
		case "MD" :
			switch (trcCtl.dataStrcVersion) {
			case 1 :
				trcCtl.dataStrcSize = 2 * MQCHAR4 + 11 * MQLONG + 3 * MQCHAR8 + 2 * MQBYTE24 + 2 * MQCHAR48 + MQCHAR12 + MQBYTE32 + MQCHAR32 + MQCHAR28; 
				break;
			case 2 :
				trcCtl.dataStrcSize = 2 * MQCHAR4 + 15 * MQLONG + 3 * MQCHAR8 + 3 * MQBYTE24 + 2 * MQCHAR48 + MQCHAR12 + MQBYTE32 + MQCHAR32 + MQCHAR28; 
				break;
			default :
				trcCtl.dataStrcName = null;
				trcCtl.dataStrcVersion = 0;
				break;
			}
			break;
		case "OD" :
			switch (trcCtl.dataStrcVersion) {
			case 1 :
				trcCtl.dataStrcSize = MQCHAR4 + 2 * MQLONG + 3 * MQCHAR48 + MQCHAR12; 
				break;
			case 2 :
				trcCtl.dataStrcSize = MQCHAR4 + 8 * MQLONG + 3 * MQCHAR48 + MQCHAR12 + 2 * MQPTR; 
				break;
			case 3 :
				trcCtl.dataStrcSize = MQCHAR4 + 8 * MQLONG + 5 * MQCHAR48 + MQCHAR12 + 2 * MQPTR + MQBYTE40; 
				break;
			case 4 :
				trcCtl.dataStrcSize = MQCHAR4 + 9 * MQLONG + 5 * MQCHAR48 + MQCHAR12 + 2 * MQPTR + MQBYTE40 + 3 * MQCHARV; 
				break;
			default :
				trcCtl.dataStrcName = null;
				trcCtl.dataStrcVersion = 0;
				break;
			}
			break;
		case "PD" :
			switch (trcCtl.dataStrcVersion) {
			case 1 :
				trcCtl.dataStrcSize = MQCHAR4 + 5 * MQLONG; 
				break;
			default :
				trcCtl.dataStrcName = null;
				trcCtl.dataStrcVersion = 0;
				break;
			}
			break;
		case "PMO" :
			switch (trcCtl.dataStrcVersion) {
			case 1 :
				trcCtl.dataStrcSize = MQCHAR4 + 6 * MQLONG + MQHOBJ + 2 * MQCHAR48; 
				break;
			case 2 :
				trcCtl.dataStrcSize = MQCHAR4 + 10 * MQLONG + MQHOBJ + 2 * MQCHAR48 + 2 * MQPTR; 
				break;
			case 3 :
				trcCtl.dataStrcSize = MQCHAR4 + 12 * MQLONG + MQHOBJ + 2 * MQCHAR48 + 2 * MQPTR + 2 * MQHMSG; 
				break;
			default :
				trcCtl.dataStrcName = null;
				trcCtl.dataStrcVersion = 0;
				break;
			}
			break;
		case "SD" :
			switch (trcCtl.dataStrcVersion) {
			case 1 :
				trcCtl.dataStrcSize = MQCHAR4 + 5 * MQLONG + MQCHAR48 + MQCHAR12 + MQBYTE40 + 5 * MQCHARV + MQBYTE24 + MQBYTE32 + MQCHAR32 + MQSD_padding; 
				break;
			default :
				trcCtl.dataStrcName = null;
				trcCtl.dataStrcVersion = 0;
				break;
			}
			break;
		case "SMPO" :
			switch (trcCtl.dataStrcVersion) {
			case 1 :
				trcCtl.dataStrcSize = MQCHAR4 + 4 * MQLONG; 
				break;
			default :
				trcCtl.dataStrcName = null;
				trcCtl.dataStrcVersion = 0;
				break;
			}
			break;
		case "STAT" :
			switch (trcCtl.dataStrcVersion) {
			case 1 :
				trcCtl.dataStrcSize = MQCHAR4 + 7 * MQLONG + 4 * MQCHAR48; 
				break;
			case 2 :
				trcCtl.dataStrcSize = MQCHAR4 + 9 * MQLONG + 4 * MQCHAR48 + 2 * MQCHARV; 
				break;
			default :
				trcCtl.dataStrcName = null;
				trcCtl.dataStrcVersion = 0;
				break;
			}
			break;
		default :
		}	
	}
	
	public static void processDataStrcName(TrcCtl trcCtl) {
		switch (trcCtl.dataStrcName) {
		case "Bufferlength:" :
			DataStrcUtil.processBufferlength(trcCtl);
			break;
		case "Compcode:" :
			DataStrcUtil.processCompcode(trcCtl);
			break;
		case "ConnectOpts:" :
			DataStrcUtil.processConnectOpts(trcCtl);
			break;
		case "Datalength:" :
			DataStrcUtil.processDatalength(trcCtl);
			break;
		case "Hconn:" :
			DataStrcUtil.processHconn(trcCtl);
			break;
		case "Hobj:" :
			DataStrcUtil.processHobj(trcCtl);
			break;
		case "Hmsg:" :
			DataStrcUtil.processHmsg(trcCtl);
			break;
		case "Options:" :
			DataStrcUtil.processOptions(trcCtl);
			break;
		case "Reason:" :
			DataStrcUtil.processReason(trcCtl);
			break;
		case "Buffer:" :
			DataStrcUtil.processBuffer(trcCtl);
			break;
		case "aatBuffer:" :
			DataStrcUtil.processBuffer(trcCtl);
			break;
		case "CBC" :
			DataStrcUtil.processCBC(trcCtl);
			break;
		case "CBD" :
			DataStrcUtil.processCBD(trcCtl);
			break;
		case "CMHO" :
			DataStrcUtil.processCMHO(trcCtl);
			break;
		case "CTLO" :
			DataStrcUtil.processCTLO(trcCtl);
			break;
		case "DMHO" :
			DataStrcUtil.processDMHO(trcCtl);
			break;
		case "DMPO" :
			DataStrcUtil.processDMPO(trcCtl);
			break;
		case "GMO" :
			DataStrcUtil.processGMO(trcCtl);
			break;
		case "IMPO" :
			DataStrcUtil.processIMPO(trcCtl);
			break;
		case "MD" :
			DataStrcUtil.processMD(trcCtl);
			break;
		case "OD" :
			DataStrcUtil.processOD(trcCtl);
			break;
		case "PD" :
			DataStrcUtil.processPD(trcCtl);
			break;
		case "PMO" :
			DataStrcUtil.processPMO(trcCtl);
			break;
		case "SD" :
			DataStrcUtil.processSD(trcCtl);
			break;
		case "SMPO" :
			DataStrcUtil.processSMPO(trcCtl);
			break;
		case "STAT" :
			DataStrcUtil.processSTAT(trcCtl);
			break;
		default :
		}
	}
	
	public static void processBufferlength(TrcCtl trcCtl) {
		// if we have encountered a hex line, print out the data structure that we have parsed
		if (trcCtl.hexLine)
		{
			int offset = 0;
			
			trcCtl.indent = trcCtl.tmpIndent;
			String padStr = TrcParser.padString(trcCtl);
			trcCtl.dataStrcSize = trcCtl.dsBufferOffset;
			
			// Bufferlength
			if (!TrcParser.writeEqualInt(trcCtl, padStr, "Bufferlength", offset))
				return;
			
			trcCtl.resetDataStrc();

		}
		
		return;

	}

	public static void processCompcode(TrcCtl trcCtl) {
		// if we have encountered a hex line, print out the data structure that we have parsed
		if (trcCtl.hexLine)
		{
			int offset = 0;
			
			trcCtl.indent = trcCtl.tmpIndent;
			String padStr = TrcParser.padString(trcCtl);
			trcCtl.dataStrcSize = trcCtl.dsBufferOffset;
			
			// Compcode
			if (!TrcParser.writeEqualInt(trcCtl, padStr, "Compcode", offset))
				return;
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}
	public static void processConnectOpts(TrcCtl trcCtl) {

		// if we have encountered a hex line, print out the data structure that we have parsed
		if (trcCtl.hexLine)
		{
			int offset = 0;
			
			trcCtl.indent = trcCtl.tmpIndent;
			String padStr = TrcParser.padString(trcCtl);
			trcCtl.dataStrcSize = trcCtl.dsBufferOffset;
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   Connect Options expanded (Options field only):");
			
			// MQCNO.Options
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MQCNO.Options", offset+8))
				return;
						
			trcCtl.resetDataStrc();
		}
		
		return;

	}
	public static void processDatalength(TrcCtl trcCtl) {
		// if we have encountered a hex line, print out the data structure that we have parsed
		if (trcCtl.hexLine)
		{
			int offset = 0;
			
			trcCtl.indent = trcCtl.tmpIndent;
			String padStr = TrcParser.padString(trcCtl);
			trcCtl.dataStrcSize = trcCtl.dsBufferOffset;
			
			// Datalength
			if (!TrcParser.writeEqualInt(trcCtl, padStr, "Datalength", offset))
				return;
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}
	public static void processHconn(TrcCtl trcCtl) {
		// if we have encountered a hex line, print out the data structure that we have parsed
		if (trcCtl.hexLine)
		{
			int offset = 0;
			
			trcCtl.indent = trcCtl.tmpIndent;
			String padStr = TrcParser.padString(trcCtl);
			trcCtl.dataStrcSize = trcCtl.dsBufferOffset;
			
			// Hconn
			if (!TrcParser.writeEqualBytes(trcCtl, padStr, "Hconn", 4, offset))
				return;
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}
	public static void processHobj(TrcCtl trcCtl) {
		// if we have encountered a hex line, print out the data structure that we have parsed
		if (trcCtl.hexLine)
		{
			int offset = 0;
			
			trcCtl.indent = trcCtl.tmpIndent;
			String padStr = TrcParser.padString(trcCtl);
			trcCtl.dataStrcSize = trcCtl.dsBufferOffset;
			
			// Hobj
			if (!TrcParser.writeEqualBytes(trcCtl, padStr, "Hobj", 4, offset))
				return;
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}
	
	public static void processHmsg(TrcCtl trcCtl) {
		// if we have encountered a hex line, print out the data structure that we have parsed
		if (trcCtl.hexLine)
		{
			int offset = 0;
			
			trcCtl.indent = trcCtl.tmpIndent;
			String padStr = TrcParser.padString(trcCtl);
			trcCtl.dataStrcSize = trcCtl.dsBufferOffset;
			
			// Hmsg
			if (!TrcParser.writeEqualBytes(trcCtl, padStr, "Hmsg", 8, offset))
				return;
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}

	public static void processOptions(TrcCtl trcCtl) {
		// if we have encountered a hex line, print out the data structure that we have parsed
		if (trcCtl.hexLine)
		{
			int offset = 0;
			
			trcCtl.indent = trcCtl.tmpIndent;
			String padStr = TrcParser.padString(trcCtl);
			trcCtl.dataStrcSize = trcCtl.dsBufferOffset;
			
			if (trcCtl.mqOpen)
			{
				TrcParser.writeOutputFile(trcCtl, padStr + "   Open Options expanded:");
			
				// StrucId
				if (!TrcParser.writeMQLONG(trcCtl, padStr, "MQOO.Options", offset))
					return;
			}
			
			if (trcCtl.mqClose)
			{
				TrcParser.writeOutputFile(trcCtl, padStr + "   Close Options expanded:");
			
				// StrucId
				if (!TrcParser.writeMQLONG(trcCtl, padStr, "MQCO.Options", offset))
					return;
			}
						
			trcCtl.mqOpen = false;
			trcCtl.mqClose = false;
			trcCtl.mqOpenCloseCt = 0;
			trcCtl.resetDataStrc();
		}
		
		return;
	}
	
	public static void processReason(TrcCtl trcCtl) {
		// if we have encountered a hex line, print out the data structure that we have parsed
		if (trcCtl.hexLine)
		{
			int offset = 0;
			
			trcCtl.indent = trcCtl.tmpIndent;
			String padStr = TrcParser.padString(trcCtl);
			trcCtl.dataStrcSize = trcCtl.dsBufferOffset;
			
			// Reason
			if (!TrcParser.writeEqualInt(trcCtl, padStr, "Reason", offset))
				return;
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}
	
	public static void processBuffer(TrcCtl trcCtl) {

		if (!trcCtl.messageSearch && !trcCtl.messageParsing && !trcCtl.msg2File && !trcCtl.msg2FileGlobal)
		{
			trcCtl.resetDataStrc();
			return;
		}
		
		if (!trcCtl.hexLine && trcCtl.messageBufferList.size() > 0)
		{
			if (trcCtl.messageParsing)
				MessageParsingUtil.printMessageParsing(trcCtl);
			
			if (trcCtl.msg2File || trcCtl.msg2FileGlobal)
			{
				MessageBufferUtil.msg2File(trcCtl);
				trcCtl.msg2File=false;
				trcCtl.msg2FileStr=null;
			}
			
			if (trcCtl.messageSearch)
				MessageBufferUtil.messageSearch(trcCtl);
				
			
			trcCtl.resetDataStrc();
		}
		else
		{
			// We only use 32 bytes of trcCtl.dsBuffer for storing the Buffer: data. 
			// Copy current line to previous line and reset trcCtl.dsBufferOffset to 16
			if (trcCtl.dsBufferOffset >= 32)
			{
				for (int k=0; k < 16; k++)
					trcCtl.dsBuffer[k] = trcCtl.dsBuffer[k+16];
				trcCtl.dsBufferOffset = 16;
			}
		}
		
		return;
	}
	
	public static void processCBC(TrcCtl trcCtl) {
		// if we have reached our data structure size, print out the data structure that we have parsed
		if (trcCtl.dsBufferOffset >= trcCtl.dataStrcSize)
		{
			int offset = 0;
			
			String padStr = TrcParser.padString(trcCtl);
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   CbContext expanded (all fields):");
			
			// StrucId
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "StrucId", 4, offset))
				return;
			offset=offset+4;
			
			// Version
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Version", offset))
				return;
			offset=offset+4;
			
			// CallType
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "CallType", offset))
				return;
			offset=offset+4;
			
			// Hobj
			if (!TrcParser.writeMQBYTE(trcCtl, padStr, "Hobj", 4, offset))
				return;
			offset=offset+4;
			
			// CallbackArea
			if (!TrcParser.writeMQPTR(trcCtl, padStr, "CallbackArea", TrcParser.pointerLength, offset))
				return;
			offset=offset+TrcParser.pointerLength;
			
			// ConnectionArea
			if (!TrcParser.writeMQPTR(trcCtl, padStr, "ConnectionArea", TrcParser.pointerLength, offset))
				return;
			offset=offset+TrcParser.pointerLength;
			
			// CompCode
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "CompCode", offset))
				return;
			offset=offset+4;
			
			// Reason
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Reason", offset))
				return;
			offset=offset+4;
			
			// State
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "State", offset))
				return;
			offset=offset+4;
			
			// DataLength
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "DataLength", offset))
				return;
			offset=offset+4;
			
			// BufferLength
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "BufferLength", offset))
				return;
			offset=offset+4;
			
			// Flags
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Flags", offset))
				return;
			offset=offset+4;			
			
			// ReconnectDelay
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "ReconnectDelay", offset))
				return;
			offset=offset+4;						
			
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}
	public static void processCBD(TrcCtl trcCtl) {
		// if we have reached our data structure size, print out the data structure that we have parsed
		if (trcCtl.dsBufferOffset >= trcCtl.dataStrcSize)
		{
			int offset = 0;
			
			String padStr = TrcParser.padString(trcCtl);
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   CallbackDesc expanded (all fields):");
			
			// StrucId
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "StrucId", 4, offset))
				return;
			offset=offset+4;
			
			// Version
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Version", offset))
				return;
			offset=offset+4;
			
			// CallBackType
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "CallBackType", offset))
				return;
			offset=offset+4;
			
			// MQCBDO.Options
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MQCBDO.Options", offset))
				return;
			offset=offset+4;
			            			
			// CallbackArea
			if (!TrcParser.writeMQPTR(trcCtl, padStr, "CallbackArea", TrcParser.pointerLength, offset))
				return;
			offset=offset+TrcParser.pointerLength;
			
			// CallbackFunction
			if (!TrcParser.writeMQPTR(trcCtl, padStr, "CallbackFunction", TrcParser.pointerLength, offset))
				return;
			offset=offset+TrcParser.pointerLength;
			
			// CallbackName
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "CallbackName", 128, offset))
				return;
			offset=offset+128;
			
			// MaxMsgLength
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MaxMsgLength", offset))
				return;
			offset=offset+4;			
			
			
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}
	public static void processCMHO(TrcCtl trcCtl) {
		// if we have reached our data structure size, print out the data structure that we have parsed
		if (trcCtl.dsBufferOffset >= 12)
		{
			int offset = 0;
			
			trcCtl.indent = trcCtl.tmpIndent;
			String padStr = TrcParser.padString(trcCtl);
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   CrtMsgHOpts expanded:");
			
			// MQCMHO.Options
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MQCMHO.Options", offset+8))
				return;
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}
	public static void processCTLO(TrcCtl trcCtl) {		
		// if we have reached our data structure size, print out the data structure that we have parsed
		if (trcCtl.dsBufferOffset >= 12)
		{
			int offset = 0;
			
			trcCtl.indent = trcCtl.tmpIndent;
			String padStr = TrcParser.padString(trcCtl);
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   Consumer Control Options expanded:");
			
			// MQCTLO.Options
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MQCTLO.Options", offset+8))
				return;
			
			trcCtl.resetDataStrc();
		}
		
		return; }
	public static void processDMHO(TrcCtl trcCtl) {		
		// if we have reached our data structure size, print out the data structure that we have parsed
		if (trcCtl.dsBufferOffset >= 12)
		{
			int offset = 0;
			
			trcCtl.indent = trcCtl.tmpIndent;
			String padStr = TrcParser.padString(trcCtl);
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   DltMsgHOpts expanded:");
			
			// MQDMHO.Options
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MQDMHO.Options", offset+8))
				return;
			
			trcCtl.resetDataStrc();
		}
		
		return; }
	public static void processDMPO(TrcCtl trcCtl) {
		// if we have reached our data structure size, print out the data structure that we have parsed
		if (trcCtl.dsBufferOffset >= 12)
		{
			int offset = 0;
			
			String padStr = TrcParser.padString(trcCtl);
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   DltPropOpts expanded:");
			
			// MQDMPO.Options
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MQDMPO.Options", offset+8))
				return;
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}
	public static void processGMO(TrcCtl trcCtl) {
		// if we have reached our data structure size, print out the data structure that we have parsed
		if (trcCtl.dsBufferOffset >= trcCtl.dataStrcSize)
		{
			int offset = 0;
			
			String padStr = TrcParser.padString(trcCtl);
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   Getmsgopts expanded (all fields):");
			
			// StrucId
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "StrucId", 4, offset))
				return;
			offset=offset+4;
			
			// Version
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Version", offset))
				return;
			offset=offset+4;
			
			// MQGMO.Options
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MQGMO.Options", offset))
				return;
			offset=offset+4;
			
			// WaitInterval
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "WaitInterval", offset))
				return;
			offset=offset+4;
			
			// Signal1
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Signal1", offset))
				return;
			offset=offset+4;
			
			// Signal2
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Signal2", offset))
				return;
			offset=offset+4;
			
			// ResolvedQName
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "ResolvedQName", 48, offset))
				return;
			offset=offset+48;
			
			// MatchOptions
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MatchOptions", offset))
				return;
			offset=offset+4;
			
			// GroupStatus
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "GroupStatus", 1, offset))
				return;
			offset=offset+1;
			
			// SegmentStatus
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "SegmentStatus", 1, offset))
				return;
			offset=offset+1;
			
			// Segmentation
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "Segmentation", 1, offset))
				return;
			offset=offset+1;
			
			// Reserved1
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "Reserved1", 1, offset))
				return;
			offset=offset+1;
			
			// MsgToken
			if (!TrcParser.writeMQBYTE(trcCtl, padStr, "MsgToken", 16, offset))
				return;
			offset=offset+16;
			
			// ReturnedLength
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "ReturnedLength", offset))
				return;
			offset=offset+4;
			
			// Reserved2
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Reserved2", offset))
				return;
			offset=offset+4;
			
			// MsgHandle
			if (!TrcParser.writeMQBYTE(trcCtl, padStr, "MsgHandle", 8, offset))
				return;
			offset=offset+8;
			
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}
	public static void processIMPO(TrcCtl trcCtl) {
		// if we have reached our data structure size, print out the data structure that we have parsed
		if (trcCtl.dsBufferOffset >= trcCtl.dataStrcSize)
		{
			int offset = 0;
			
			String padStr = TrcParser.padString(trcCtl);
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   InqPropOpts expanded (all fields):");
			
			// StrucId
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "StrucId", 4, offset))
				return;
			offset=offset+4;
			
			// Version
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Version", offset))
				return;
			offset=offset+4;
			
			// MQIMPO.Options
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MQIMPO.Options", offset))
				return;
			offset=offset+4;
			
			// RequestedEncoding
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "RequestedEncoding", offset))
				return;
			offset=offset+4;
			
			// RequestedCCSID
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "RequestedCCSID", offset))
				return;
			offset=offset+4;
			
			// ReturnedEncoding
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "ReturnedEncoding", offset))
				return;
			offset=offset+4;
			
			// ReturnedCCSID
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "ReturnedCCSID", offset))
				return;
			offset=offset+4;
			
			// Reserved1
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Reserved1", offset))
				return;
			offset=offset+4;
			
			// ReturnedName
			if (!TrcParser.writeMQCHARV(trcCtl, padStr, "ReturnedName", offset))
				return;
			offset=offset+TrcParser.pointerLength+16;
			
			// TypeString
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "TypeString", 8, offset))
				return;
			offset=offset+8;
			
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}
	
	public static void processMD(TrcCtl trcCtl) { 
		// if we have reached our data structure size, print out the data structure that we have parsed
		if (trcCtl.dsBufferOffset >= trcCtl.dataStrcSize)
		{
			int offset = 0;
			
			String padStr = TrcParser.padString(trcCtl);
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   Msgdesc expanded (all fields):");
			
			// StrucId
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "StrucId", 4, offset))
				return;
			offset=offset+4;
			
			// Version
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Version", offset))
				return;
			offset=offset+4;
			
			// Report
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Report", offset))
				return;
			offset=offset+4;
			
			// MsgType
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MsgType", offset))
				return;
			offset=offset+4;
			
			// Expiry
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Expiry", offset))
				return;
			offset=offset+4;
			
			// Feedback
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Feedback", offset))
				return;
			offset=offset+4;
			
			// Encoding
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Encoding", offset))
				return;
			offset=offset+4;
			
			// CodedCharSetId
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "CodedCharSetId", offset))
				return;
			trcCtl.CCSID = TrcParser.dsBuffer4BytesToInt(trcCtl, offset);
			offset=offset+4;
			
			// Format
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "Format", 8, offset))
				return;
			trcCtl.format = TrcParser.getStringFromDSBuffer(trcCtl, "format", offset, 8);
			offset=offset+8;
			
			// Priority
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Priority", offset))
				return;
			offset=offset+4;
			
			// Persistence
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Persistence", offset))
				return;
			offset=offset+4;
			
			// MsgId
			if (!TrcParser.writeMQBYTE(trcCtl, padStr, "MsgId", 24, offset))
				return;
			offset=offset+24;
			
			// CorrelId
			if (!TrcParser.writeMQBYTE(trcCtl, padStr, "CorrelId", 24, offset))
				return;
			offset=offset+24;
			
			// BackoutCount
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "BackoutCount", offset))
				return;
			offset=offset+4;
			
			// ReplyToQ
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "ReplyToQ", 48, offset))
				return;
			offset=offset+48;
			
			// ReplyToQMgr
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "ReplyToQMgr", 48, offset))
				return;
			offset=offset+48;
			
			// UserIdentifier
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "UserIdentifier", 12, offset))
				return;
			offset=offset+12;
			
			// AccountingToken
			if (!TrcParser.writeMQBYTE(trcCtl, padStr, "AccountingToken", 32, offset))
				return;
			offset=offset+32;
			
			// ApplIdentityData
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "ApplIdentityData", 32, offset))
				return;
			offset=offset+32;
			
			// PutApplType
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "PutApplType", offset))
				return;
			offset=offset+4;
			
			// PutApplName
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "PutApplName", 28, offset))
				return;
			offset=offset+28;
			
			// PutDate
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "PutDate", 8, offset))
				return;
			offset=offset+8;
			
			// PutTime
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "PutTime", 8, offset))
				return;
			offset=offset+8;
			
			// ApplOriginData
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "ApplOriginData", 4, offset))
				return;
			offset=offset+4;
			
			// GroupId
			if (!TrcParser.writeMQBYTE(trcCtl, padStr, "GroupId", 24, offset))
				return;
			offset=offset+24;
			
			// MsgSeqNumber
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MsgSeqNumber", offset))
				return;
			offset=offset+4;
			
			// Offset
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Offset", offset))
				return;
			offset=offset+4;
			
			// MsgFlags
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MsgFlags", offset))
				return;
			offset=offset+4;
			
			// OriginalLength
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "OriginalLength", offset))
				return;
			offset=offset+4;
			

			trcCtl.resetDataStrc();
		}
		
		return;
	}
	public static void processOD(TrcCtl trcCtl) { 
		// if we have reached our data structure size, print out the data structure that we have parsed
		if (trcCtl.dsBufferOffset >= trcCtl.dataStrcSize)
		{
			int offset = 0;
			
			String padStr = TrcParser.padString(trcCtl);
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   Objdesc expanded (all fields):");
			
			// StrucId
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "StrucId", 4, offset))
				return;
			offset=offset+4;
			
			// Version
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Version", offset))
				return;
			offset=offset+4;
			
			// ObjectType
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "ObjectType", offset))
				return;
			offset=offset+4;
			
			// ObjectName
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "ObjectName", 48, offset))
				return;
			offset=offset+48;
			
			// ObjectQMgrName
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "ObjectQMgrName", 48, offset))
				return;
			offset=offset+48;
			
			// DynamicQName
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "DynamicQName", 48, offset))
				return;
			offset=offset+48;
			
			// AlternateUserId
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "AlternateUserId", 12, offset))
				return;
			offset=offset+12;
			
			// RecsPresent
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "RecsPresent", offset))
				return;
			offset=offset+4;
			
			// KnownDestCount
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "KnownDestCount", offset))
				return;
			offset=offset+4;
			
			// UnknownDestCount
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "UnknownDestCount", offset))
				return;
			offset=offset+4;
			
			// InvalidDestCount
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "InvalidDestCount", offset))
				return;
			offset=offset+4;
			
			// ObjectRecOffset
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "ObjectRecOffset", offset))
				return;
			offset=offset+4;
			
			// ResponseRecOffset
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "ResponseRecOffset", offset))
				return;
			offset=offset+4;
			
			// ObjectRecPtr
			if (!TrcParser.writeMQPTR(trcCtl, padStr, "ObjectRecPtr", TrcParser.pointerLength, offset))
				return;
			offset=offset+TrcParser.pointerLength;
			
			// ResponseRecPtr
			if (!TrcParser.writeMQPTR(trcCtl, padStr, "ResponseRecPtr", TrcParser.pointerLength, offset))
				return;
			offset=offset+TrcParser.pointerLength;
			
			// AltSecurityId
			if (!TrcParser.writeMQBYTE(trcCtl, padStr, "AltSecurityId", 40, offset))
				return;
			offset=offset+40;
			
			// ResolvedQName
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "ResolvedQName", 48, offset))
				return;
			offset=offset+48;
			
			// ResolvedQMgrName
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "ResolvedQMgrName", 48, offset))
				return;
			offset=offset+48;
			
			// ObjectString
			if (!TrcParser.writeMQCHARV(trcCtl, padStr, "ObjectString", offset))
				return;
			offset=offset+TrcParser.pointerLength+16;
			
			// SelectionString
			if (!TrcParser.writeMQCHARV(trcCtl, padStr, "SelectionString", offset))
				return;
			offset=offset+TrcParser.pointerLength+16;
			
			// ResObjectString
			if (!TrcParser.writeMQCHARV(trcCtl, padStr, "ResObjectString", offset))
				return;
			offset=offset+TrcParser.pointerLength+16;
			
			// ResolvedType
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "ResolvedType", offset))
				return;
			offset=offset+4;
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}
	public static void processPMO(TrcCtl trcCtl) {
		// if we have reached our data structure size, print out the data structure that we have parsed
		if (trcCtl.dsBufferOffset >= trcCtl.dataStrcSize)
		{
			int offset = 0;
			
			String padStr = TrcParser.padString(trcCtl);
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   Putmsgopts expanded (all fields):");
			
			// StrucId
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "StrucId", 4, offset))
				return;
			offset=offset+4;
			
			// Version
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Version", offset))
				return;
			offset=offset+4;
			
			// MQPMO.Options
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MQPMO.Options", offset))
				return;
			offset=offset+4;
			
			// Timeout
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Timeout", offset))
				return;
			offset=offset+4;
			
			// Context
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Context", offset))
				return;
			offset=offset+4;
			
			// KnownDestCount
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "KnownDestCount", offset))
				return;
			offset=offset+4;
			
			// UnknownDestCount
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "UnknownDestCount", offset))
				return;
			offset=offset+4;
			
			// InvalidDestCount
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "InvalidDestCount", offset))
				return;
			offset=offset+4;
			
			// ResolvedQName
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "ResolvedQName", 48, offset))
				return;
			offset=offset+48;
			
			// ResolvedQMgrName
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "ResolvedQMgrName", 48, offset))
				return;
			offset=offset+48;
			
			// RecsPresent
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "RecsPresent", offset))
				return;
			offset=offset+4;
			
			// PutMsgRecFields
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "PutMsgRecFields", offset))
				return;
			offset=offset+4;
			
			// PutMsgRecOffset
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "PutMsgRecOffset", offset))
				return;
			offset=offset+4;
			
			// ResponseRecOffset
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "ResponseRecOffset", offset))
				return;
			offset=offset+4;
            
			// PutMsgRecPtr
			if (!TrcParser.writeMQPTR(trcCtl, padStr, "PutMsgRecPtr", TrcParser.pointerLength, offset))
				return;
			offset=offset+TrcParser.pointerLength;
			
			// ResponseRecPtr
			if (!TrcParser.writeMQPTR(trcCtl, padStr, "ResponseRecPtr", TrcParser.pointerLength, offset))
				return;
			offset=offset+TrcParser.pointerLength;
			
			// OrigMsgHandle
			if (!TrcParser.writeMQBYTE(trcCtl, padStr, "OrigMsgHandle", 8, offset))
				return;
			offset=offset+8;
			
			// NewMsgHandle
			if (!TrcParser.writeMQBYTE(trcCtl, padStr, "NewMsgHandle", 8, offset))
				return;
			offset=offset+8;
			
			// Action
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Action", offset))
				return;
			offset=offset+4;
			
			// PubLevel
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "PubLevel", offset))
				return;
			offset=offset+4;			
			
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}
	public static void processSD(TrcCtl trcCtl) {
		// if we have reached our data structure size, print out the data structure that we have parsed
		if (trcCtl.dsBufferOffset >= trcCtl.dataStrcSize)
		{
			int offset = 0;
			
			String padStr = TrcParser.padString(trcCtl);
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   Subdesc expanded (all fields):");
			
			// StrucId
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "StrucId", 4, offset))
				return;
			offset=offset+4;
			
			// Version
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Version", offset))
				return;
			offset=offset+4;
			
			// MQSD.Options
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MQSD.Options", offset))
				return;
			offset=offset+4;
			
			// ObjectName
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "ObjectName", 48, offset))
				return;
			offset=offset+48;
			
			// AlternateUserId
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "AlternateUserId", 12, offset))
				return;
			offset=offset+12;
			
			// AltSecurityId
			if (!TrcParser.writeMQBYTE(trcCtl, padStr, "AltSecurityId", 40, offset))
				return;
			offset=offset+40;
			
			// SubExpiry
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "SubExpiry", offset))
				return;
			offset=offset+4;
			
			if (TrcParser.pointerLength == 8)
			{
				// StructurePadding
				if (!TrcParser.writeMQCHAR(trcCtl, padStr, "StructurePadding", 4, offset))
					return;
				offset=offset+4;				
			}
			
			// ObjectString
			if (!TrcParser.writeMQCHARV(trcCtl, padStr, "ObjectString", offset))
				return;
			offset=offset+TrcParser.pointerLength+16;
			
			// SubName
			if (!TrcParser.writeMQCHARV(trcCtl, padStr, "SubName", offset))
				return;
			offset=offset+TrcParser.pointerLength+16;
			
			// SubUserData
			if (!TrcParser.writeMQCHARV(trcCtl, padStr, "SubUserData", offset))
				return;
			offset=offset+TrcParser.pointerLength+16;
			
			// SubCorrelId
			if (!TrcParser.writeMQBYTE(trcCtl, padStr, "SubCorrelId", 24, offset))
				return;
			offset=offset+24;
			
			// PubPriority
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "PubPriority", offset))
				return;
			offset=offset+4;
			
			// PubAcctToken
			if (!TrcParser.writeMQBYTE(trcCtl, padStr, "PubAcctToken", 32, offset))
				return;
			offset=offset+32;
			
			// PubApplIdntData
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "PubApplIdntData", 32, offset))
				return;
			offset=offset+32;
			
			if (TrcParser.pointerLength == 8)
			{
				// StructurePadding
				if (!TrcParser.writeMQCHAR(trcCtl, padStr, "StructurePadding", 4, offset))
					return;
				offset=offset+4;				
			}
			
			// SelectionString
			if (!TrcParser.writeMQCHARV(trcCtl, padStr, "SelectionString", offset))
				return;
			offset=offset+TrcParser.pointerLength+16;
			
			// SubLevel
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "SubLevel", offset))
				return;
			offset=offset+4;
			
			if (TrcParser.pointerLength == 8)
			{
				// StructurePadding
				if (!TrcParser.writeMQCHAR(trcCtl, padStr, "StructurePadding", 4, offset))
					return;
				offset=offset+4;				
			}
			
			// ResObjectString
			if (!TrcParser.writeMQCHARV(trcCtl, padStr, "ResObjectString", offset))
				return;
			offset=offset+TrcParser.pointerLength+16;			
			
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}
	public static void processPD(TrcCtl trcCtl) {
		// if we have reached our data structure size, print out the data structure that we have parsed
		if (trcCtl.dsBufferOffset >= trcCtl.dataStrcSize)
		{
			int offset = 0;
			
			String padStr = TrcParser.padString(trcCtl);
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   PropDesc expanded (all fields):");
			
			// StrucId
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "StrucId", 4, offset))
				return;
			offset=offset+4;
			
			// Version
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Version", offset))
				return;
			offset=offset+4;
			
			// MQPD.Options
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MQPD.Options", offset))
				return;
			offset=offset+4;
			
			// Support
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Support", offset))
				return;
			offset=offset+4;
			
			// Context
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "PD.Context", offset))
				return;
			offset=offset+4;
			
			// CopyOptions
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "CopyOptions", offset))
				return;
			offset=offset+4;
			
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}

	public static void processSMPO(TrcCtl trcCtl) {
		// if we have reached our data structure size, print out the data structure that we have parsed
		if (trcCtl.dsBufferOffset >= trcCtl.dataStrcSize)
		{
			int offset = 0;
			
			String padStr = TrcParser.padString(trcCtl);
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   SetPropOpts expanded (all fields):");
			
			// StrucId
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "StrucId", 4, offset))
				return;
			offset=offset+4;
			
			// Version
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Version", offset))
				return;
			offset=offset+4;
			
			// MQSMPO.Options
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "MQSMPO.Options", offset))
				return;
			offset=offset+4;
			
			// ValueEncoding
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "ValueEncoding", offset))
				return;
			offset=offset+4;
			
			// ValueCCSID
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "ValueCCSID", offset))
				return;
			offset=offset+4;
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}	
	public static void processSTAT(TrcCtl trcCtl) {
		// if we have reached our data structure size, print out the data structure that we have parsed
		if (trcCtl.dsBufferOffset >= trcCtl.dataStrcSize)
		{
			int offset = 0;
			
			String padStr = TrcParser.padString(trcCtl);
			
			TrcParser.writeOutputFile(trcCtl, padStr + "   StatusData expanded (all fields):");
			
			// StrucId
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "StrucId", 4, offset))
				return;
			offset=offset+4;
			
			// Version
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Version", offset))
				return;
			offset=offset+4;
			
			// CompCode
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "CompCode", offset))
				return;
			offset=offset+4;
			
			// Reason
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "Reason", offset))
				return;
			offset=offset+4;
			
			// PutSuccessCount
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "PutSuccessCount", offset))
				return;
			offset=offset+4;
			
			// PutWarningCount
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "PutWarningCount", offset))
				return;
			offset=offset+4;
			
			// PutFailureCount
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "PutFailureCount", offset))
				return;
			offset=offset+4;
			
			// ObjectType
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "ObjectType", offset))
				return;
			offset=offset+4;
			
			// ObjectName
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "ObjectName", 48, offset))
				return;
			offset=offset+48;
			
			// ObjectQMgrName
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "ObjectQMgrName", 48, offset))
				return;
			offset=offset+48;
			
			// RslvObjectName
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "RslvObjectName", 48, offset))
				return;
			offset=offset+48;
			
			// ResolvedQMgrName
			if (!TrcParser.writeMQCHAR(trcCtl, padStr, "ResolvedQMgrName", 48, offset))
				return;
			offset=offset+48;
			
			// ObjectString
			if (!TrcParser.writeMQCHARV(trcCtl, padStr, "ObjectString", offset))
				return;
			offset=offset+TrcParser.pointerLength+16;
			
			// SubName
			if (!TrcParser.writeMQCHARV(trcCtl, padStr, "SubName", offset))
				return;
			offset=offset+TrcParser.pointerLength+16;
			
			// OpenOptions
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "OpenOptions", offset))
				return;
			offset=offset+4;
			
			// SubOptions
			if (!TrcParser.writeMQLONG(trcCtl, padStr, "SubOptions", offset))
				return;
			offset=offset+4;
			
			trcCtl.resetDataStrc();
		}
		
		return;
	}

}
