package mqtrcfrmt.parser;

import java.io.*;
import java.util.*;

public class TrcCtl {
	public String pidTid;
	public int pidTidPos;
	public String outputTrcFile;
	public BufferedOutputStream outputTrcBufferedFileStream;
	public String inputFileCharset;
	public int lineNmbr;
	public String mqAPI;
	public String mqAPIType;
	public String mqAPITimestamp;
	public String mqPrevAPI;
	public String mqPrevAPIType;
	public String mqPrevAPITimestamp;
	HashMap <String, APITracker> apihm;
	public String format;
	public int CCSID;
	public String dataStrcName;
	public int dataStrcVersion;
	public int dataStrcSize;
	public byte [] dsBuffer;
	public int dsBufferOffset;
	public int dsBufferMax;
	public int indent;
	public int tmpIndent;
	public boolean mqOpen;
	public boolean mqClose;
	public int mqOpenCloseCt;
	public boolean hexLine;
	public short pointerLength;
	public short bytesParsed;
	public boolean messageSearch;
	public String messageSearchStr;
	public String messageSearchStr2;
	public String messageSearchStr3;
	public String messageSearchStr4;
	public short messageSearchStrCt;
	public int messageSearchStrMax;
	public boolean messageParsing;
	public int messageParsingValue;
	public boolean msg2File;
	public String msg2FileStr;
	public boolean msg2FileGlobal;
	public String msg2FileGlobalStr;
	public int msg2FileGlobalCt;
	public LinkedList<MessageBuffer> messageBufferList;
	public LinkedList<MessageParsingTracker> messageParsingTrackerList;
	public short messageParsingMBLength;
	public short messageParsingMBContCt;
	public int messageParsingTotalBytes;
	public int messageParsingASCIIBytes;
	public int messageParsingInvalidBytes;
	public int messageParsingMB2TotalBytes;
	public int messageParsingMB3TotalBytes;
	public int messageParsingMB4TotalBytes;
	public short messageParsingBomBECt;
	public short messageParsingBomLECt;
	public boolean messageParsingSpFlag;
	public int messageParsingSpContCt;
	public int messageParsingSpTotCt;
	public int messageParsingASCIILeadByte;
	public ActivityTraceTracker atTracker;
    public TreeMap <String, ActivityTraceRecord> atrTreeMap;
		
	public TrcCtl (String key) {
		pidTid = key;
		pidTidPos = 0;
		outputTrcFile = null;
		inputFileCharset = null;
		lineNmbr = 0;
		mqAPI = null;
		mqAPIType = null;
		mqAPITimestamp = null;
		mqPrevAPI = null;
		mqPrevAPIType = null;
		mqPrevAPITimestamp = null;
		apihm = new HashMap<String, APITracker>();
		format = null;
		CCSID = 0;		
		dataStrcName = null;
		dataStrcVersion = 0;
		dataStrcSize = 0;
		dsBufferMax = 16384;
		dsBuffer = new byte[dsBufferMax];
		dsBufferOffset = 0;
		indent = 0;
		tmpIndent = 0;
		mqOpen = false;
		mqClose = false;
		mqOpenCloseCt = 0;
		hexLine = false;
		pointerLength = 0;
		bytesParsed = 0;
		messageSearch = false;
		messageSearchStr = null;
		messageSearchStr2 = null;
		messageSearchStr3 = null;
		messageSearchStr4 = null;
		messageSearchStrCt = 0;
		messageSearchStrMax = 0;
		messageParsing = false;
		messageParsingValue = 0;
		msg2File = false;
		msg2FileStr = null;
		msg2FileGlobal = false;
		msg2FileGlobalStr = null;
		msg2FileGlobalCt = 0;
		messageBufferList = new LinkedList<MessageBuffer>();
		messageParsingTrackerList = new LinkedList<MessageParsingTracker>();
		messageParsingMBLength = 0;
		messageParsingMBContCt = 0;
		messageParsingTotalBytes = 0;
		messageParsingASCIIBytes = 0;
		messageParsingInvalidBytes = 0;
		messageParsingMB2TotalBytes = 0;
		messageParsingMB3TotalBytes = 0;
		messageParsingMB4TotalBytes = 0;
		messageParsingBomBECt = 0;
		messageParsingBomLECt = 0;
		messageParsingSpFlag = false;
		messageParsingSpContCt = 0;
		messageParsingSpTotCt = 0;
		messageParsingASCIILeadByte = -1;
		atTracker = null;
		atrTreeMap = null;
	}
	
	public void resetDataStrc( ) {
		this.lineNmbr = 0;
		this.dataStrcName = null;
		this.dataStrcVersion = 0;
		this.dataStrcSize = 0;
		this.dsBufferOffset = 0;
		this.indent = 0;
		this.tmpIndent = 0;
		this.hexLine = false;
		this.bytesParsed = 0;
		this.messageBufferList.clear();
		this.messageParsingTrackerList.clear();
		this.messageParsingMBLength = 0;
		this.messageParsingMBContCt = 0;
		this.messageParsingTotalBytes = 0;
		this.messageParsingASCIIBytes = 0;
		this.messageParsingInvalidBytes = 0;
		this.messageParsingMB2TotalBytes = 0;
		this.messageParsingMB3TotalBytes = 0;
		this.messageParsingMB4TotalBytes = 0;
		this.messageParsingBomBECt = 0;
		this.messageParsingBomLECt = 0;
		this.messageParsingSpFlag = false;
		this.messageParsingSpContCt = 0;
		this.messageParsingSpTotCt = 0;
		this.messageParsingASCIILeadByte = -1;
	}

}
